#ifndef COLLECT_KINETIC_ENERGY_H
#define COLLECT_KINETIC_ENERGY_H

#ifndef COLLECT_SCALAR_H
#include "Collect_scalar.h"
#endif

#ifndef INTERACTION_H
#include "Interaction.h"
#endif

namespace MM
{
class Prototype;

class Collect_kinetic_energy : public Collect_scalar
{
public:
    explicit Collect_kinetic_energy (Atom_group & atom_group, Text in);

    // Constructor for prototype only.
    Collect_kinetic_energy (Prototype const &);

    virtual Monitor *       clone (Atom_group & atom_group,
                                   Text const & args, Text in) const;

    Text                    title      () const {return "Kinetic energy";}
    Text                    class_name () const {return "Collect_kinetic_energy";}
    virtual double          extract_current_value ();
};

}//MM

#endif //COLLECT_KINETIC_ENERGY_H
